package com.huimv.env.common.dao.repo;

import com.huimv.env.common.dao.entity.EnvElectricityMeter;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.sql.Date;
import java.util.List;

public interface EnvElectricityMeterRepo extends JpaRepository<EnvElectricityMeter, Integer>, JpaSpecificationExecutor<EnvElectricityMeter> {

    @Query(nativeQuery = true,value = "SELECT *  FROM env_electricity_meter WHERE device_code=?1  ORDER BY id DESC LIMIT 1")
    EnvElectricityMeter getOneByMaxId(String deviceCode);

    @Query(nativeQuery = true,value = "SELECT SUM(electricity_meter) total FROM `env_electricity_meter` WHERE farm_code=?1 AND device_code=?2 AND add_date=?3")
    List<Object[]> getSumElectricityMeter(String farmCode, String deviceCode, Date todayDate);
}