package com.huimv.env.common.dao.repo;

import com.huimv.env.common.dao.entity.EnvElectricityMeter;
import com.huimv.env.common.dao.entity.EnvWaterMeter;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.sql.Date;
import java.util.List;

public interface EnvWaterMeterRepo extends JpaRepository<EnvWaterMeter, Integer>, JpaSpecificationExecutor<EnvWaterMeter> {

    @Query(nativeQuery = true,value = "SELECT *  FROM env_water_meter WHERE device_code=?1  ORDER BY id DESC LIMIT 1")
    EnvWaterMeter getOneByMaxId(String deviceCode);

    @Query(nativeQuery = true,value = "SELECT SUM(water_meter) total FROM `env_water_meter` WHERE farm_code=?1 AND device_code=?2 AND add_date=?3 ORDER BY add_time DESC")
    List<Object[]> getSumWaterMeter(String farmCode, String deviceCode, Date todayDate);
}