package com.huimv.env.common.mapper;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.huimv.env.common.entity.EnvWaterDay;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.huimv.env.common.entity.EnvWaterMonth;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.sql.Date;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zn
 * @since 2022-10-20
 */
public interface EnvWaterDayMapper extends BaseMapper<EnvWaterDay> {

    Map<String, String> getSumDayWaterMeter(@Param(Constants.WRAPPER) QueryWrapper<EnvWaterMonth> queryWrapper);

    @Select("SELECT SUM(day_water) AS total FROM `env_water_day` WHERE farm_code=${farmCode} AND device_code=${deviceCode} AND add_date BETWEEN ${startDate} AND ${endDate}")
    String sumDayWaterMeter(@Param("farmCode") String farmCode, @Param("deviceCode") String deviceCode,@Param("startDate") Date startDate,@Param("endDate") Date endDate);
}
