package com.huimv.env.common.service;

import com.alibaba.fastjson.JSONObject;
import com.huimv.common.utils.Result;
import com.huimv.env.common.dao.entity.EnvDeviceRegisterEntity;
import com.huimv.env.common.entity.EnvElectricityDay;
import com.baomidou.mybatisplus.extension.service.IService;

import java.sql.Date;
import java.sql.Timestamp;
import java.text.ParseException;
import java.util.Map;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author zn
 * @since 2022-10-21
 */
public interface EnvElectricityDayService extends IService<EnvElectricityDay> {

    EnvElectricityDay getDayElectricityConsumption(String farmCode, String deviceCode, String sensorSn, Date todayDate);

    void saveDayElectricity(JSONObject dataJo, EnvDeviceRegisterEntity envDeviceRegisterEntity, Timestamp nowTimestamp, Date todayDate, String farmCode);

    void updateDayElectricity(float sumElectricityMeter, EnvElectricityDay envElectricityDay, JSONObject dataJo, EnvDeviceRegisterEntity envDeviceRegisterEntity, Timestamp nowTimestamp, Date todayDate, String farmCode);

    Result getTodayElectricity(Map<String, String> paramsMap) throws ParseException;

    Result getElectricityCount(Map<String, String> paramsMap) throws ParseException;

    float getSumElectricityMeter(String farmCode, String deviceCode, Date date, Date date1);
}
