package com.huimv.env.common.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.env.common.dao.entity.LampConfigEntity;
import com.huimv.env.common.dao.entity.LampTempEntity;
import com.huimv.env.common.dao.repo.LampConfigEntityRepo;
import com.huimv.env.common.dao.repo.LampTempEntityRepo;
import com.huimv.env.common.entity.LampTemp;
import com.huimv.env.common.mapper.LampTempMapper;
import com.huimv.env.common.service.ILampTempService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.xml.ws.ServiceMode;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.Date;
import java.util.Optional;

/**
 * @Project : huimv-env-platform
 * @Package : ${}
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2022/10/15
 **/
@Service
public class LampTempServiceImpl implements ILampTempService {
    @Autowired
    private LampTempMapper lampTempMapper;

    @Override
    public BigDecimal getLastLampTemp(String farmCode) {
        QueryWrapper<LampTemp> queryWrapper = new QueryWrapper();
        queryWrapper.eq("farm_code",farmCode);
        queryWrapper.orderByDesc("add_time");
        queryWrapper.last("LIMIT 1");
        LampTemp lampTemp = lampTempMapper.selectOne(queryWrapper);
        if(lampTemp == null){
            return new BigDecimal(0);
        }else{
            return new BigDecimal(lampTemp.getTemp());
        }
    }


    @Resource
    private LampTempEntityRepo lampTempEntityRepo;
    @Resource
    private LampConfigEntityRepo lampConfigEntityRepo;
    @Override
    public int saveLampTemp(String deviceId, String temp, Date addTime) {
        try {
            LampConfigEntity LampConfigEntity = new LampConfigEntity();
            LampConfigEntity.setDeviceId(deviceId);
            Example<LampConfigEntity> example = Example.of(LampConfigEntity);
            if (!lampConfigEntityRepo.findOne(example).isPresent()){
                System.out.println("保温灯不存在");
                return -1;
            }
            LampConfigEntity one =lampConfigEntityRepo.findOne(example).get();
            LampTempEntity lampTempEntity = new LampTempEntity();
            lampTempEntity.setDeviceId(deviceId);
            lampTempEntity.setTemp(temp);
            lampTempEntity.setFarmCode(one.getFarmCode());
            lampTempEntity.setAddTime(new Timestamp(addTime.getTime()));
            lampTempEntityRepo.saveAndFlush(lampTempEntity);
            return 0;
        }catch (Exception e){
            System.out.println("保温灯报错--->"+e);
            return 1;
        }

    }
}

