package com.huimv.env.manage.saas.controller;


import com.huimv.env.manage.saas.dao.entity.LampConfig;
import com.huimv.env.manage.saas.service.ILampConfigService;
import com.huimv.env.manage.utils.Result;
import com.huimv.env.manage.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2022-10-18
 */
@RestController
@CrossOrigin
@RequestMapping("/lampConfig")
public class LampConfigController {

    @Autowired
    ILampConfigService lampConfigService;

    @PostMapping("/savelampConfig")
    public Result savelampConfig(@RequestBody LampConfig lampConfig, HttpServletRequest request){

        return lampConfigService.savelampConfig(lampConfig,request);
    }

    @PostMapping("/lsitAllLamp")
    public Result lsitAllLamp(@RequestBody Map<String, String> map, HttpServletRequest request){
        return lampConfigService.lsitAllLamp(map,request);
    }
    @PostMapping("/unbindingLamp")
    public Result unbindingLamp(@RequestBody Map<String, String> map, HttpServletRequest request){
        return lampConfigService.unbindingLamp(map,request);
    }

    @PostMapping("/bindingBaseLamp")
    public Result bindingBaseLamp(@RequestBody Map<String, String> map, HttpServletRequest request){
        return lampConfigService.bindingBaseLamp(map,request);

    }

    @PostMapping("/remove")
    public Result remove(@RequestBody Map<String, String> map, HttpServletRequest request){
        String ids = map.get("ids");
        String[] split = ids.split(",");
        for (String id : split) {
            lampConfigService.removeById(id);
        }
        return  new Result(10000,"删除成功",true);
    }

    // 保温灯统一配置 -配置
    @PostMapping("/allToConfig")
    public Result allToConfig(@RequestBody Map<String, Object> map, HttpServletRequest request){
        return lampConfigService.allToConfig(map,request);
    }
    // 保温板统一配置 -配置
    @PostMapping("/allToBoardGear")
    public Result allToBoardGear(@RequestBody Map<String, Object> map, HttpServletRequest request){
        return lampConfigService.allToBoardGear(map,request);
    }



    @PostMapping("/listByUnit")
    public Result listByUnit(@RequestBody Map<String, String> map, HttpServletRequest request){
        return lampConfigService.listByUnit(map,request);

    }


    @PostMapping("/countByUnit")
    public Result countByUnit(@RequestBody Map<String, String> map, HttpServletRequest request){
        return lampConfigService.countByUnit(map,request);

    }


    // 保温灯开关
    @PostMapping("/updateLamp")
    public Result updateLamp(@RequestBody Map<String, Object> map, HttpServletRequest request){
        return lampConfigService.updateLamp(map,request);

    }


    @PostMapping("/listByLampId")
    public Result listByLampId(@RequestBody Map<String, String> map, HttpServletRequest request){
        return lampConfigService.listByLampId(map,request);

    }


}
