package com.huimv.env.manage.saas.mqtt.subscribe;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.env.common.entity.BaseThreshold;
import com.huimv.env.common.service.IBaseThresholdService;
import com.huimv.env.manage.entity.*;
import com.huimv.env.manage.saas.dao.entity.EnvDeviceEquipment;
import com.huimv.env.manage.saas.mqtt.publish.PublishMQTT;
import com.huimv.env.manage.saas.mqtt.utils.SpringUtil;
import com.huimv.env.manage.saas.service.IEnvDeviceEquipmentService;
import com.huimv.env.manage.service.*;
import lombok.extern.slf4j.Slf4j;
import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;
import org.eclipse.paho.client.mqttv3.MqttCallback;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;
import java.time.ZonedDateTime;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Component
//接收消息回调
@Slf4j
public class PushCallbackTest implements MqttCallback {


    @Override
    public void connectionLost(Throwable cause) {
        // 连接丢失后，一般在这里面进行重连
        System.out.println("连接断开，可以做重连");
    }

    @Override
    public void deliveryComplete(IMqttDeliveryToken token) {
        System.out.println("deliveryComplete---------" + token.isComplete());
    }

    @Override
    public void messageArrived(String topic, MqttMessage message) throws Exception {
        // subscribe后得到的消息会执行到这里面
        System.out.println("接收消息主题 : " + topic);
        System.out.println("接收消息Qos : " + message.getQos());
        System.out.println("接收消息内容 : " + new String(message.getPayload()));
        System.out.println("开始处理当前数据...");

        String s = new String(message.getPayload());
        IEnvTopicService envTopicService = SpringUtil.getBean(IEnvTopicService.class);
        Date date = new Date();
        EnvTopic envTopic = new EnvTopic();
        envTopic.setTime(date);
        if ("sync_time".equals(s)) {
            envTopic.setTopic(0);
            System.out.println("收到控制响应");
            System.out.println("数据处理完成！");
        } else {
            envTopic.setTopic(1);
            System.out.println("操作失败");
        }
        envTopicService.save(envTopic);
    }
}
