package com.huimv.env.manage.saas.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.env.manage.entity.EnvDeviceRegister;
import com.huimv.env.manage.entity.EnvHumi;
import com.huimv.env.manage.entity.EnvTemp;
import com.huimv.env.manage.entity.dto.AllDataDto;
import com.huimv.env.manage.mapper.*;
import com.huimv.env.manage.saas.dao.entity.BaseDeviceCofig;
import com.huimv.env.manage.saas.dao.entity.EnvElectricityMeter;
import com.huimv.env.manage.saas.dao.entity.EnvPh;
import com.huimv.env.manage.saas.dao.entity.EnvWaterMeter;
import com.huimv.env.manage.saas.service.IBaseDeviceCofigService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.env.manage.utils.Result;
import com.huimv.env.manage.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2022-10-18
 */
@Service
public class BaseDeviceCofigServiceImpl extends ServiceImpl<BaseDeviceCofigMapper, BaseDeviceCofig> implements IBaseDeviceCofigService {

    @Autowired
    private EnvTempMapper tempMapper;

    @Autowired
    private EnvHumiMapper envHumiMapper;

    @Autowired
    private EnvPhMapper envPhMapper;

    @Autowired
    private EnvElectricityMeterMapper envElectricityMeterMapper;

    @Autowired
    private EnvWaterMeterMapper waterMeterMapper;

    @Autowired
    private EnvDeviceRegisterMapper envDeviceRegisterMapper;



    @Override
    public Result listAllDataByUnitId(Map<String, String> map, HttpServletRequest request) {
        String unitId = map.get("unitId");
        EnvDeviceRegister deviceRegister = envDeviceRegisterMapper.selectOne(new QueryWrapper<EnvDeviceRegister>().eq("unit_id", unitId));
        if (ObjectUtil.isEmpty(deviceRegister)){
            return new Result(10001,"未绑定设备",true);
        }
        String deviceCode = deviceRegister.getDeviceCode();
        Date beginOfDay = DateUtil.beginOfDay(new Date());
        AllDataDto dataDto = envDeviceRegisterMapper.selectAllData(deviceCode,beginOfDay);
        return new Result(ResultCode.SUCCESS,dataDto);

       /* Map endMap = new HashMap();
        endMap.put("temp",0);
        endMap.put("envHumi",0);
        endMap.put("envPh",0);
        endMap.put("envElectricityMeter",0);
        endMap.put("envWaterMeter",0);




        EnvTemp temp = tempMapper.selectOne(new QueryWrapper<EnvTemp>().eq("device_code",deviceCode ).orderByDesc("id").last("limit 1"));
        EnvHumi envHumi = envHumiMapper.selectOne(new QueryWrapper<EnvHumi>().eq("device_code", deviceCode).orderByDesc("id").last("limit 1"));
        EnvPh envPh = envPhMapper.selectOne(new QueryWrapper<EnvPh>().eq("device_code", deviceCode).orderByDesc("id").last("limit 1"));
        Double  envWaterMeter =  waterMeterMapper.countDay(new QueryWrapper<EnvWaterMeter>().eq("device_code", deviceCode).ge("ask_time", DateUtil.beginOfDay(new Date())));
        Double  envElectricityMeter =  envElectricityMeterMapper.countDay(new QueryWrapper<EnvElectricityMeter>().eq("device_code", deviceCode).ge("ask_time", DateUtil.beginOfDay(new Date())));

        if (ObjectUtil.isNotEmpty(temp)){
            endMap.put("temp",temp.getTemp());
        }
        if (ObjectUtil.isNotEmpty(envHumi)){
            endMap.put("envHumi",envHumi.getHumi());
        }
        if (ObjectUtil.isNotEmpty(envPh)){
            endMap.put("envPh",envPh.getPh());
        }
        if (ObjectUtil.isNotEmpty(envWaterMeter)){
            endMap.put("envWaterMeter",envWaterMeter);
        }
        if (ObjectUtil.isNotEmpty(envElectricityMeter)){
            endMap.put("envElectricityMeter",envElectricityMeter);
        }
        return new Result(ResultCode.SUCCESS,endMap);*/
    }
}
