package com.huimv.env.manage.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.env.manage.entity.EnvAmmonia;
import com.huimv.env.manage.mapper.EnvAmmoniaMapper;
import com.huimv.env.manage.service.IEnvAmmoniaService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.env.manage.utils.Result;
import com.huimv.env.manage.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author author
 * @since 2022-08-18
 */
@Service
public class EnvAmmoniaServiceImpl extends ServiceImpl<EnvAmmoniaMapper, EnvAmmonia> implements IEnvAmmoniaService {

    @Autowired
    private EnvAmmoniaMapper ammoniaMapper;

    @Override
    public Result list(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String deviceCode = paramsMap.get("deviceCode");
        QueryWrapper<EnvAmmonia> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("unit_id", deviceCode);
        DateTime dateTime = DateUtil.beginOfDay(new Date());
        queryWrapper.ge("add_time", dateTime);
        queryWrapper.orderByAsc("add_time");
        List<EnvAmmonia> envAmmonias = ammoniaMapper.selectList(queryWrapper);
        List<Map> list = new ArrayList<>();
        if (ObjectUtil.isNotEmpty(envAmmonias)) {
            for (EnvAmmonia envAmmonia : envAmmonias) {
                Map map = new HashMap();
                map.put("dataValue", envAmmonia.getAmmonia());
                Date addTime = envAmmonia.getAddTime();
                SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                map.put("time", df.format(addTime));
                list.add(map);
            }
        } else {
            Map map = new HashMap();
            map.put("dataValue", 0);
            map.put("time", 0);
            list.add(map);
        }
        return new Result(ResultCode.SUCCESS, list);
    }
}
