package com.huimv.env.manage.service.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.env.common.utils.Const;
import com.huimv.env.manage.mapper.EnvPhMapper;
import com.huimv.env.manage.saas.dao.entity.EnvPh;
import com.huimv.env.manage.service.EnvPhService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.env.manage.utils.ResultUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-10-26
 */
@Service
public class EnvPhServiceImpl extends ServiceImpl<EnvPhMapper, EnvPh> implements EnvPhService {
    @Resource
    private EnvPhMapper envPhMapper;

    @Override
    public Result getPh(Map<String, String> paramsMap) {
        String farmCode = paramsMap.get("farmCode");
        String unitId = paramsMap.get("unitId");
        QueryWrapper<EnvPh> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(StringUtils.isNotBlank(unitId),"unit_id",unitId);
        queryWrapper.eq("farm_code",farmCode);
        queryWrapper.orderByAsc("add_time");
        queryWrapper.last("LIMIT 1");
        EnvPh envPh = envPhMapper.selectOne(queryWrapper);
        if (envPh == null) {
            return new Result(Const.ERR_EMPTY_CODE, Const.ERR_EMPTY_INFO, false);
        } else {
            return new Result(ResultCode.SUCCESS, envPh);
        }
    }

    @Override
    public Result getPhList(Map<String, String> paramsMap) {
        String unitId = paramsMap.get("unitId");
        QueryWrapper<EnvPh> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(StringUtils.isNotBlank(unitId),"unit_id",unitId);
        queryWrapper.ge("add_time", DateUtil.beginOfDay(new Date()));
        queryWrapper.orderByDesc("add_time");
        queryWrapper.groupBy("DATE_FORMAT(add_time,'%Y-%m-%d %H') ");
        List<EnvPh> list = envPhMapper.selectList(queryWrapper);
        if (ObjectUtil.isNotEmpty(list)){
            return new Result(ResultCode.SUCCESS,list);
        }else {
            return new Result(ResultCode.FAIL,null);
        }
    }
}
