package com.huimv.env.produce.controller;


import com.huimv.common.utils.Result;
import com.huimv.env.produce.entity.FeedDay;
import com.huimv.env.produce.service.FeedDayService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-11-03
 */
@RestController
@RequestMapping("/v1.0.0/feed")
public class FeedDayController {
    @Autowired
    private FeedDayService feedDayService;

    //查询
    @PostMapping("/getFeedCount")
    public Result getFeedCount(@RequestBody Map<String, String> paramsMap) throws ParseException {
        //
        return feedDayService.getFeedCount(paramsMap);
    }

    //删除
    @PostMapping("/list")
    public Result listDayFeed(@RequestBody Map<String,String> paramsMap) {
        //
        return feedDayService.listDayFeed(paramsMap);
    }

    //添加
    @PostMapping("/new")
    public Result newFeedCount(@RequestBody Map<String, String> paramsMap) throws ParseException {
        //
        return feedDayService.newDayFeed(paramsMap);
    }

    //添加
    @PostMapping("/newFeedCount_old")
    public Result newFeedCount(@RequestBody List<FeedDay> list) throws ParseException {
        //
        return feedDayService.newFeedCount(list);
    }

    //删除
    @PostMapping("/remove")
    public Result removeFeedCount(@RequestBody Map<String,String> paramsMap) throws ParseException {
        //
        return feedDayService.removeFeedCount(paramsMap);
    }
}

