package com.huimv.env.produce.controller;


import com.huimv.common.utils.Result;
import com.huimv.env.produce.entity.Indicator;
import com.huimv.env.produce.service.IndicatorService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.ParseException;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-10-30
 */
@RestController
@RequestMapping("/v1.0.0/indicator")
public class IndicatorController {
    @Autowired
    private IndicatorService indicatorService;

    @PostMapping("/getIndicator")
    public Result getIndicator(@RequestBody Map<String, String> paramsMap) throws ParseException {
        //
        return indicatorService.getIndicator(paramsMap);
    }

    @PostMapping("/list")
    public Result list(@RequestBody Map<String, String> paramsMap) throws ParseException {
        //
        return indicatorService.list(paramsMap);
    }

    @PostMapping("/add")
    public Result add(@RequestBody Map<String, String> paramsMap) throws ParseException {
        //
        return indicatorService.add(paramsMap);
    }

    @PostMapping("/edit")
    public Result edit(@RequestBody Indicator indicator) throws ParseException {
        //
        return indicatorService.edit(indicator);
    }

    @PostMapping("/remove")
    public Result remove(@RequestBody Map<String, String> paramsMap) throws ParseException {
        //
        return indicatorService.remove(paramsMap);
    }

    @PostMapping("/findIndicator")
    public Result find(@RequestBody Map<String, String> paramsMap) throws ParseException {
        //
        return indicatorService.findIndicator(paramsMap);
    }

//    @PostMapping("/preserve")
//    public Result preserve(@RequestBody Indicator indicator) throws ParseException {
//        //
//        return indicatorService.preserve(indicator);
//    }

    @PostMapping("/preserve")
    public Result preserve(@RequestBody Map<String, String> paramsMap) throws ParseException {
        //
        return indicatorService.preserve(paramsMap);
    }
}

