package com.huimv.env.produce.controller;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.env.produce.service.DataSourceService;
import com.huimv.env.produce.service.ReminderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.client.RestTemplate;

import java.text.ParseException;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-11-02
 */
@RestController
@RequestMapping("/v1.0.0/reminder")
public class ReminderController {
    @Autowired
    private ReminderService reminderService;
    @Autowired
    private DataSourceService dataSourceService;
    @Autowired
    private RestTemplate restTemplate;

    //查询
    @PostMapping("/getReminder")
    public Result getReminder(@RequestBody Map<String, String> paramsMap) throws ParseException {
        return reminderService.getReminder(paramsMap);
    }

    //查询
    @PostMapping("/save")
    public Result save(@RequestBody Map<String, String> paramsMap) throws ParseException {
        return reminderService.save(paramsMap);
    }

    //查询
    @PostMapping("/listTodayPlan")
    public Result listTodayPlan(@RequestBody Map<String, String> paramsMap) throws ParseException {
        Integer dsStatu = dataSourceService.getDataSourceStatus(paramsMap);
        if (dsStatu == null) {
            dsStatu = 0;
        }
        if (dsStatu == 1) {
            //读取远程历史存栏
            return getTodayPlan(paramsMap);
        } else {
            //读取填报数据
            return reminderService.listTodayPlan(paramsMap);
        }
    }

    private Result getTodayPlan(Map<String, String> paramsMap) {
        HttpHeaders httpHeaders = new HttpHeaders();
        MediaType type = MediaType.parseMediaType("application/json;charset=UTF-8");
        httpHeaders.setContentType(type);
//        MultiValueMap<String, Object> map=new LinkedMultiValueMap<>();
        HashMap<String, Object> map = new HashMap<>();
        map.put("farmCode", paramsMap.get("farmCode"));
        HttpEntity<Map<String, Object>> objectHttpEntity = new HttpEntity<>(map, httpHeaders);
        //读取真实数据
        String remoteUrl = "http://123.60.134.84:10001/breed/api/v1.0.0/immunity/listTodayPlan";
        ResponseEntity<String> entity = restTemplate.postForEntity(remoteUrl, objectHttpEntity, String.class);
        if(entity.getStatusCode().toString().contains("200")){
            String body = entity.getBody();
            System.out.println(body);
            JSONObject dataJo = JSON.parseObject(body).getJSONObject("data");
            System.out.println("dataJo="+dataJo);
            //, )
            return new Result(ResultCode.SUCCESS,dataJo);
        }else{
            return new Result(ResultCode.FAIL,"调取远程数据出错.");
        }
    }

}

